head	1.5;
access;
symbols;
locks;
comment	@ * @;


1.5
date	92.05.11.04.22.58;	author karn;	state Exp;
branches;
next	1.4;

1.4
date	92.05.03.13.22.52;	author karn;	state Exp;
branches;
next	1.3;

1.3
date	92.05.01.12.29.44;	author karn;	state Exp;
branches;
next	1.2;

1.2
date	92.04.20.07.48.08;	author karn;	state Exp;
branches;
next	1.1;

1.1
date	92.04.09.08.54.00;	author karn;	state Exp;
branches;
next	;


desc
@src0410
@


1.5
log
@src0514
@
text
@#include <errno.h>
#include "global.h"
#include "mbuf.h"
#include "socket.h"
#include "usock.h"

int
so_los(up,protocol)
struct usock *up;
int protocol;
{
	up->cb.local = (struct loc *) callocw(1,sizeof(struct loc));
	up->cb.local->peer = up;	/* connect to self */
	up->type = TYPE_LOCAL_STREAM;
	up->cb.local->hiwat = LOCSFLOW;
	return 0;
}
int
so_lod(up,protocol)
struct usock *up;
int protocol;
{
	up->cb.local = (struct loc *) callocw(1,sizeof(struct loc));
	up->cb.local->peer = up;	/* connect to self */
	up->type = TYPE_LOCAL_DGRAM;
	up->cb.local->hiwat = LOCDFLOW;
	return 0;
}
int
so_lo_recv(up,bpp,from,fromlen)
struct usock *up;
struct mbuf **bpp;
char *from;
int *fromlen;
{
	int s;

	while(up->cb.local != NULLLOC && up->cb.local->q == NULLBUF
	  && up->cb.local->peer != NULLUSOCK){
		if(up->noblock){
			errno = EWOULDBLOCK;
			return -1;
		} else if((errno = pwait(up)) != 0){
			return -1;
		}
	}
	if(up->cb.local == NULLLOC){
		/* Socket went away */
		errno = EBADF;
		return -1;
	}
	if(up->cb.local->q == NULLBUF &&
	   up->cb.local->peer == NULLUSOCK){
		errno = ENOTCONN;
		return -1;
	}
	/* For datagram sockets, this will return the
	 * first packet on the queue. For stream sockets,
	 * this will return everything.
	 */
	*bpp = dequeue(&up->cb.local->q);
	if(up->cb.local->q == NULLBUF && (up->cb.local->flags & LOC_SHUTDOWN)){
		s = up->index;
		close_s(s);
	}
	psignal(up,0);
	return len_p(*bpp);
}
int
so_los_send(up,bp,to)
struct usock *up;
struct mbuf *bp;
char *to;
{
	if(up->cb.local->peer == NULLUSOCK){
		free_p(bp);
		errno = ENOTCONN;
		return -1;
	}
	append(&up->cb.local->peer->cb.local->q,bp);
	psignal(up->cb.local->peer,0);
	/* If high water mark has been reached, block */
	while(up->cb.local->peer != NULLUSOCK &&
	      len_p(up->cb.local->peer->cb.local->q) >=
	      up->cb.local->peer->cb.local->hiwat){
		if(up->noblock){
			errno = EWOULDBLOCK;
			return -1;
		} else if((errno = pwait(up->cb.local->peer)) != 0){
			return -1;
		}
	}
	if(up->cb.local->peer == NULLUSOCK){
		errno = ENOTCONN;
		return -1;
	}
	return 0;
}
int	
so_lod_send(up,bp,to)
struct usock *up;
struct mbuf *bp;
char *to;
{
	if(up->cb.local->peer == NULLUSOCK){
		free_p(bp);
		errno = ENOTCONN;
		return -1;
	}
	enqueue(&up->cb.local->peer->cb.local->q,bp);
	psignal(up->cb.local->peer,0);
	/* If high water mark has been reached, block */
	while(up->cb.local->peer != NULLUSOCK &&
	      len_q(up->cb.local->peer->cb.local->q) >=
	      up->cb.local->peer->cb.local->hiwat){
		if(up->noblock){
			errno = EWOULDBLOCK;
			return -1;
		} else if((errno = pwait(up->cb.local->peer)) != 0){
			return -1;
		}
	}
	if(up->cb.local->peer == NULLUSOCK){
		errno = ENOTCONN;
		return -1;
	}
	return 0;
}
int
so_lod_qlen(up,rtx)
struct usock *up;
int rtx;
{
	int len;

	switch(rtx){
	case 0:
		len = len_q(up->cb.local->q);
		break;
	case 1:
		if(up->cb.local->peer != NULLUSOCK)
			len = len_q(up->cb.local->peer->cb.local->q);
		break;
	}
	return len;
}
int
so_los_qlen(up,rtx)
struct usock *up;
int rtx;
{
	int len;

	switch(rtx){
	case 0:
		len = len_p(up->cb.local->q);
		break;
	case 1:
		if(up->cb.local->peer != NULLUSOCK)
			len = len_p(up->cb.local->peer->cb.local->q);
		break;
	}
	return len;
}
int
so_loc_shut(up,how)
struct usock *up;
int how;
{
	int s;

	s = up->index;

	if(up->cb.local->q == NULLBUF)
		close_s(s);
	else
		up->cb.local->flags = LOC_SHUTDOWN;
	return 0;
}
int
so_loc_close(up)
struct usock *up;
{
	if(up->cb.local->peer != NULLUSOCK){
		up->cb.local->peer->cb.local->peer = NULLUSOCK;
		psignal(up->cb.local->peer,0);
	}
	free_q(&up->cb.local->q);
	free(up->cb.local);
	return 0;
}
char *
lopsocket(p)
struct sockaddr *p;
{
	return "";
}
so_loc_stat(up)
struct usock *up;
{
	int s;

	s = up->index;

	printf("Inqlen: %d packets\n",socklen(s,0));
	printf("Outqlen: %d packets\n",socklen(s,1));
	return 0;
}
@


1.4
log
@src0503
@
text
@d63 1
a63 1
		s = up - Usock + SOCKBASE;
d172 1
a172 1
	s = up - Usock + SOCKBASE;
d203 1
a203 1
	s = up - Usock + SOCKBASE;
@


1.3
log
@src0501
@
text
@d48 1
d69 1
a69 1
int	
@


1.2
log
@src0419
@
text
@d155 1
a155 1
		len = len_p(up->cb.local->q) + len_p(up->ibuf);
d159 1
a159 2
			len = len_p(up->cb.local->peer->cb.local->q)
			      + len_p(up->obuf);
d204 2
a205 2
	tprintf("Inqlen: %d packets\n",socklen(s,0));
	tprintf("Outqlen: %d packets\n",socklen(s,1));
@


1.1
log
@Initial revision
@
text
@d1 1
@
