head	1.4;
access;
symbols;
locks;
comment	@ * @;


1.4
date	93.05.06.10.10.17;	author karn;	state Exp;
branches;
next	1.3;

1.3
date	91.09.21.12.14.40;	author karn;	state Exp;
branches;
next	1.2;

1.2
date	91.06.07.06.51.22;	author karn;	state Exp;
branches;
next	1.1;

1.1
date	91.03.16.15.35.10;	author karn;	state Exp;
branches;
next	;


desc
@src0318
@


1.4
log
@Change int16 to uint16
Remove __ARGS(()) construct
@
text
@#ifndef _PPPFSM_H
#define _PPPFSM_H

#ifndef	_MBUF_H
#include "mbuf.h"
#endif

#ifndef	_PROC_H
#include "proc.h"
#endif

#ifndef	_IFACE_H
#include "iface.h"
#endif

#ifndef	_TIMER_H
#include "timer.h"
#endif

				/* 00: serious internal problems */
				/* 01: interoperability problems */
				/* 02: state machine messages */
#define PPP_DEBUG_RAW
#define PPP_DEBUG_OPTIONS	0x08
#define PPP_DEBUG_CHECKS(x)	if(PPPtrace & 0x40) trace_log(PPPiface,x);
#define PPP_DEBUG_ROUTINES(x)	if(PPPtrace & 0x80) trace_log(PPPiface,x);

/* config packet header */
struct config_hdr {
	byte_t code;
#define CONFIG_REQ	 1
#define CONFIG_ACK	 2
#define CONFIG_NAK	 3
#define CONFIG_REJ	 4
#define TERM_REQ	 5
#define TERM_ACK	 6
#define CODE_REJ	 7
#define PROT_REJ	 8
#define ECHO_REQ	 9
#define ECHO_REPLY	10
#define DISCARD_REQ	11
#define QUALITY_REPORT	12

	byte_t id;
	uint16 len;
};
#define CONFIG_HDR_LEN	4	/* Length of config packet header */


/* config option header */
struct option_hdr {
	byte_t type;		/* protocol dependant types */
	byte_t len;
};
#define OPTION_HDR_LEN	2	/* Length of option header */


/* Supported Configuration Protocol index */
enum {
	Lcp,
	Pap,
	IPcp,
	fsmi_Size
};

struct fsm_s;		/* forward declaration */

/* Protocol Constants needed by State Machine */
struct fsm_constant_s {
	char *name;			/* Name of protocol */
	uint16 protocol;			/* Protocol number */
	uint16 recognize;		/* Config codes to use (bits) */

	byte_t fsmi;			/* Finite State Machine index */
	byte_t try_req;			/* # tries for request */
	byte_t try_nak;			/* # tries for nak substitutes */
	byte_t try_terminate;		/* # tries for terminate */
	int32 timeout;			/* Time for timeouts (milliseconds)*/

	/* To free structure */
	void (*free)(struct fsm_s *fsm_p);

	/* Set negotiation to initial values */
	void (*reset)(struct fsm_s *fsm_p);
	/* When leaving Closed or Listen */
	void (*starting)(struct fsm_s *fsm_p);
	/* When entering Opened */
	void (*opening)(struct fsm_s *fsm_p);
	/* When leaving Opened */
	void (*closing)(struct fsm_s *fsm_p);
	/* When entering Closed or Listen (after termination) */
	void (*stopping)(struct fsm_s *fsm_p);

	struct mbuf *(*makereq)(struct fsm_s *fsm_p);

	int (*request)(struct fsm_s *fsm_p,
					struct config_hdr *hdr,
					struct mbuf *bp);
	int (*ack)(struct fsm_s *fsm_p,
					struct config_hdr *hdr,
					struct mbuf *bp);
	int (*nak)(struct fsm_s *fsm_p,
					struct config_hdr *hdr,
					struct mbuf *bp);
	int (*reject)(struct fsm_s *fsm_p,
					struct config_hdr *hdr,
					struct mbuf *bp);
};

/* FSM states */
enum {
	fsmCLOSED,
	fsmLISTEN,
	fsmREQ_Sent,
	fsmACK_Rcvd,
	fsmACK_Sent,
	fsmOPENED,
	fsmTERM_Sent,
	fsmState_Size
};

/* State Machine Control Block */
struct fsm_s {
	byte_t state;			/* FSM state */
	byte_t lastid;			/* ID of last REQ we sent */

	byte_t flags;
#define PPP_ESCAPED	0x01
#define PPP_TOSS	0x02
#define FSM_PASSIVE	0x40	/* opened passive */
#define FSM_ACTIVE	0x80	/* opened active */

	byte_t retry;			/* counter for timeouts */
	byte_t try_req;			/* # tries for request */
	byte_t try_terminate;		/* # tries for terminate */

	byte_t retry_nak;		/* counter for naks of requests */
	byte_t try_nak;			/* # tries for nak substitutes */

	struct ppp_s *ppp_p;		/* the ppp we belong to */
	struct timer timer;
	struct fsm_constant_s *pdc;	/* protocol dependent constants */
	void *pdv;			/* protocol dependent variables */
};


/* Link Phases */
enum {
	pppDEAD,		/* Waiting for physical layer */
	pppLCP,			/* Link Control Phase */
	pppAP,			/* Authentication Phase */
	pppREADY,		/* Link ready for traffic */
	pppTERMINATE,		/* Termination Phase */
	pppPhase_Size
};

/* PPP control block */
struct ppp_s {
	struct iface *iface;		/* pointer to interface block */

	byte_t phase;			/* phase of link initialization */
	byte_t id;			/* id counter for connection */

	byte_t flags;
#define PPP_AP_LOCAL	0x10	/* local authentication */
#define PPP_AP_REMOTE	0x20	/* remote authentication */

	byte_t trace;			/* trace flags for connection */

	struct fsm_s fsm[fsmi_Size];	/* finite state machines */

	int32 upsince;			/* Timestamp when Link Opened */
	char *peername;			/* Peername from remote (if any) */

	int32 OutTxOctetCount;		/* # octets sent */
	int32 OutOpenFlag;		/* # of open flags sent */
	uint16 OutNCP[fsmi_Size];	/* # NCP packets sent by protocol */
	uint16 OutError;			/* # packets with error on send */
	uint16 OutMemory;		/* # alloc failures on send */

	int32 InRxOctetCount;		/* # octets received */
	int32 InOpenFlag;		/* # of open flags */
	uint16 InNCP[fsmi_Size];		/* # NCP packets by protocol */
	uint16 InUnknown;		/* # unknown packets received */
	uint16 InChecksum;		/* # packets with bad checksum */
	uint16 InFrame;			/* # packets with frame error */
	uint16 InError;			/* # packets with other error */
	uint16 InMemory; 		/* # alloc failures */
};
#define NULLPPP	(struct ppp_s *)0


extern char *fsmStates[];
extern char *fsmCodes[];

struct mbuf *htoncnf(struct config_hdr *cnf, struct mbuf *data);
int ntohcnf(struct config_hdr *cnf, struct mbuf **bpp);
int ntohopt(struct option_hdr *opt, struct mbuf **bpp);

void fsm_no_action(struct fsm_s *fsm_p);
int fsm_no_check(struct fsm_s *fsm_p,
				struct config_hdr *hdr,
				struct mbuf *bp);

void fsm_log(struct fsm_s *fsm_p, char *comment);
void fsm_timer(struct fsm_s *fsm_p);

int fsm_send(struct fsm_s *fsm_p, byte_t code,
			byte_t id, struct mbuf *data);
int fsm_sendreq(struct fsm_s *fsm_p);

void fsm_proc(struct fsm_s *fsm_p, struct mbuf *bp);

void fsm_start(struct fsm_s *fsm_p);
void fsm_down(struct fsm_s *fsm_p);
void fsm_close(struct fsm_s *fsm_p);

void fsm_init(struct fsm_s *fsm_p);
void fsm_free(struct fsm_s *fsm_p);

#endif /* _PPPFSM_H */
@


1.3
log
@src0922
@
text
@d45 1
a45 1
	int16 len;
d71 2
a72 2
	int16 protocol;			/* Protocol number */
	int16 recognize;		/* Config codes to use (bits) */
d81 1
a81 1
	void (*free)		__ARGS((struct fsm_s *fsm_p));
d84 1
a84 1
	void (*reset)		__ARGS((struct fsm_s *fsm_p));
d86 1
a86 1
	void (*starting)	__ARGS((struct fsm_s *fsm_p));
d88 1
a88 1
	void (*opening)		__ARGS((struct fsm_s *fsm_p));
d90 1
a90 1
	void (*closing)		__ARGS((struct fsm_s *fsm_p));
d92 1
a92 1
	void (*stopping)	__ARGS((struct fsm_s *fsm_p));
d94 1
a94 1
	struct mbuf *(*makereq)	__ARGS((struct fsm_s *fsm_p));
d96 1
a96 1
	int (*request)		__ARGS((struct fsm_s *fsm_p,
d98 2
a99 2
					struct mbuf *bp));
	int (*ack)		__ARGS((struct fsm_s *fsm_p,
d101 2
a102 2
					struct mbuf *bp));
	int (*nak)		__ARGS((struct fsm_s *fsm_p,
d104 2
a105 2
					struct mbuf *bp));
	int (*reject)		__ARGS((struct fsm_s *fsm_p,
d107 1
a107 1
					struct mbuf *bp));
d177 3
a179 3
	int16 OutNCP[fsmi_Size];	/* # NCP packets sent by protocol */
	int16 OutError;			/* # packets with error on send */
	int16 OutMemory;		/* # alloc failures on send */
d183 6
a188 6
	int16 InNCP[fsmi_Size];		/* # NCP packets by protocol */
	int16 InUnknown;		/* # unknown packets received */
	int16 InChecksum;		/* # packets with bad checksum */
	int16 InFrame;			/* # packets with frame error */
	int16 InError;			/* # packets with other error */
	int16 InMemory; 		/* # alloc failures */
d196 3
a198 3
struct mbuf *htoncnf __ARGS((struct config_hdr *cnf, struct mbuf *data));
int ntohcnf __ARGS((struct config_hdr *cnf, struct mbuf **bpp));
int ntohopt __ARGS((struct option_hdr *opt, struct mbuf **bpp));
d200 2
a201 2
void fsm_no_action	__ARGS((struct fsm_s *fsm_p));
int fsm_no_check	__ARGS((struct fsm_s *fsm_p,
d203 1
a203 1
				struct mbuf *bp));
d205 2
a206 2
void fsm_log	__ARGS((struct fsm_s *fsm_p, char *comment));
void fsm_timer	__ARGS((struct fsm_s *fsm_p));
d208 3
a210 3
int fsm_send	__ARGS((struct fsm_s *fsm_p, byte_t code,
			byte_t id, struct mbuf *data));
int fsm_sendreq	__ARGS((struct fsm_s *fsm_p));
d212 1
a212 1
void fsm_proc	__ARGS((struct fsm_s *fsm_p, struct mbuf *bp));
d214 3
a216 3
void fsm_start	__ARGS((struct fsm_s *fsm_p));
void fsm_down	__ARGS((struct fsm_s *fsm_p));
void fsm_close	__ARGS((struct fsm_s *fsm_p));
d218 2
a219 2
void fsm_init	__ARGS((struct fsm_s *fsm_p));
void fsm_free	__ARGS((struct fsm_s *fsm_p));
@


1.2
log
@src0609
@
text
@a3 2
#include <time.h>

d20 8
a55 1
#define NULLOPTHDR	(struct option_hdr *)0
d66 2
d83 1
a83 1
	/* When State Machine is reset */
d85 1
a85 1
	/* When State Machine is started (after reset) */
d87 1
a87 1
	/* When entering Open */
d89 1
a89 1
	/* When leaving Open */
d91 1
a91 1
	/* When State Machine is stopped (after termination) */
d128 2
d172 2
a173 1
	time_t upsince;			/* Timestamp when Link Opened */
a175 1
	int32 OutTxPacketCount;		/* # packets sent */
a176 1
	int32 OutIP;			/* # IP packets sent */
d179 1
a181 1
	int32 InRxPacketCount;		/* # packets received */
a182 1
	int32 InIP;			/* # IP packets received */
a184 1
	int16 InError;			/* # packets with error */
d186 3
a188 2

	struct proc *machine;		/* connection supervisor */
a197 1
struct mbuf *htonopt __ARGS((struct option_hdr *opt));
@


1.1
log
@Initial revision
@
text
@d36 1
d74 1
a74 1
	void (*free)	__ARGS((struct fsm_s *fsm_p));
d77 1
a77 1
	void (*reset)	__ARGS((struct fsm_s *fsm_p));
d79 3
a81 1
	void (*start)	__ARGS((struct fsm_s *fsm_p));
d83 18
a100 18
	void (*closing)	__ARGS((struct fsm_s *fsm_p));
	/* When entering Open */
	void (*opening)	__ARGS((struct fsm_s *fsm_p));

	struct mbuf *(*makereq) __ARGS((struct fsm_s *fsm_p));

	int (*request)	__ARGS((struct fsm_s *fsm_p,
				struct config_hdr *hdr,
				struct mbuf *bp));
	int (*ack)	__ARGS((struct fsm_s *fsm_p,
				struct config_hdr *hdr,
				struct mbuf *bp));
	int (*nak)	__ARGS((struct fsm_s *fsm_p,
				struct config_hdr *hdr,
				struct mbuf *bp));
	int (*reject)	__ARGS((struct fsm_s *fsm_p,
				struct config_hdr *hdr,
				struct mbuf *bp));
d110 1
a110 1
	fsmOPEN,
a141 1
	pppLQP,			/* Link Quality Phase */
d163 18
a180 16
#ifndef PPP_NO_STATS
	time_t upsince;			/* Timestamp when state is PPP_OPEN */
	int32 sndpkt;			/* # packets sent on PPP interface */
	int32 sndopenflag;		/* # of open flags sent on packets */
	int16 snderr;			/* # pkts with PPP error on send */
	int32 rcvpkt;			/* # packets rcvd on PPP interface */
	int32 rcvopenflag;		/* # of open flags recd on packets */
	int16 rcverr;			/* # pkts with error */
	int16 csumerr;			/* # rcv pkts with bad PPP checksum */

	int16 snd[fsmi_Size];		/* # packets out by protocol */
	int16 rcv[fsmi_Size];		/* # packets in by protocol */
	int32 sndip;			/* # IP packets sent */
	int32 rcvip;			/* # IP packets received */
	int16 rcvunk;			/* # unknown packets received */
#endif
d194 5
d210 1
a210 1
void fsm_close	__ARGS((struct fsm_s *fsm_p, int wait));
@
