head	1.8;
access;
symbols;
locks;
comment	@ * @;


1.8
date	93.05.06.10.11.11;	author karn;	state Exp;
branches;
next	1.7;

1.7
date	92.05.19.09.41.00;	author karn;	state Exp;
branches;
next	1.6;

1.6
date	92.05.13.22.37.58;	author karn;	state Exp;
branches;
next	1.5;

1.5
date	92.05.05.11.19.16;	author karn;	state Exp;
branches;
next	1.4;

1.4
date	92.05.03.02.32.30;	author karn;	state Exp;
branches;
next	1.3;

1.3
date	92.04.20.13.52.16;	author karn;	state Exp;
branches;
next	1.2;

1.2
date	92.04.20.08.07.54;	author karn;	state Exp;
branches;
next	1.1;

1.1
date	92.04.11.09.11.30;	author karn;	state Exp;
branches;
next	;


desc
@src0411
@


1.8
log
@Change int16 to uint16
Remove __ARGS(()) construct
@
text
@/* This file contains code to print function/arg stack tracebacks
 * at run time, which is extremely useful for finding heap free() errors.
 *
 * This code is highly specific to Borland C and the 80x6 machines.
 *
 * April 10, 1992 P. Karn
 */

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
#include <time.h>
#include "global.h"
#include "proc.h"

struct symtab {
	struct symtab *next;
	unsigned short seg;
	unsigned short offs;
	char *name;
};
static struct symtab *Symtab;
static void rdsymtab(int unused,void *name,void *p);
static void clrsymtab(void);
static struct symtab *findsym(void (*)());
static int scompare();
static void paddr(void (*pc)());

static unsigned short Codeseg;

void
stktrace()
{
	int i,j;
	unsigned short far *context;
	unsigned short far *cnext;
	unsigned short far *ctmp;
	void (*pc)();
	int nargs;
	struct proc *rdproc;
	struct symtab *sp;
	extern char **_argv;
	char *mapname;
	char *cp;
	FILE *fp,*outsave;
	time_t t;

	/* Temporarily redirect stdout to file */
	if((fp = fopen("stktrace.out","at")) == NULLFILE)
		return;	/* Give up */
	outsave = Curproc->output;
	Curproc->output = fp;

	time(&t);
	printf("stktrace from proc %s at %s",Curproc->name,ctime(&t));
	Codeseg = _psp + 0x10;
#ifdef	notdef
	printf("Code base segment: %x\n",Codeseg);
#endif
	/* Construct name of map file */
	mapname = malloc(strlen(_argv[0]) + 5);
	strcpy(mapname,_argv[0]);
	if((cp = strrchr(mapname,'.')) != NULLCHAR)
		*cp = '\0';
	strcat(mapname,".map");

	/* Read the symbol table in another process to avoid overstressing
	 * the stack in this one
	 */
	rdproc = newproc("rdsymtab",512,rdsymtab,1,mapname,NULL,0);
	pwait(rdproc);
	free(mapname);

	context = MK_FP(_SS,_BP);
	pc = stktrace;

	for(i=0;i<20;i++){
		paddr(pc);
		sp = findsym(pc);
		if(sp != NULL)
			printf(" %s+%x",sp->name,FP_OFF(pc) - sp->offs);

		if(FP_OFF(context) == 0){
			/* No context left, we're done */
			putchar('\n');
			break;
		}
		cnext = MK_FP(FP_SEG(context),*context);
		/* Compute number of args to display */
		if(FP_OFF(cnext) != 0){
			nargs = cnext - context - (1 + sizeof(pc)/2);
			if(nargs > 20)
				nargs = 20; /* limit to reasonable number */
		} else {
			/* No higher level context, so just print an
			 * arbitrary fixed number of args
			 */
			nargs = 6;
		}		
		/* Args start after saved BP and return address */
		ctmp = context + 1 + sizeof(pc)/2;
		printf("(");
		for(j=0;j<nargs;j++){
			fprintf(fp,"%x",*ctmp);
			if(j < nargs-1)
				putchar(' ');
			else
				break;
			ctmp++;
		}
		printf(")\n");
#ifdef	notdef
		if(strcmp(cp,"_main") == 0)
			break;
#endif

#ifdef	LARGECODE
		pc = MK_FP(context[2],context[1]);
#else
		pc = (void (*)())MK_FP(FP_SEG(pc),context[1]);
#endif
		context = cnext;
	}
	clrsymtab();
	fclose(fp);
	Curproc->output = outsave;
}
static struct symtab *
findsym(pc)
void (*pc)();
{
	struct symtab *sp,*spprev;
	unsigned short seg,offs;
	
#ifdef	LARGECODE
	seg = FP_SEG(pc) - Codeseg;
#else
	seg = 0;	/* Small code, no segment */
#endif
	offs = FP_OFF(pc);
	spprev = NULL;
	for(sp = Symtab;sp != NULL;spprev = sp,sp = sp->next){
		if(sp->seg > seg || (sp->seg == seg && sp->offs > offs)){
			break;
		}
	}
	return spprev;
}
static void
clrsymtab()
{
	struct symtab *sp,*spnext;

	for(sp = Symtab;sp != NULL;sp = spnext){
		spnext = sp->next;
		free(sp->name);
		free(sp);
	}
	Symtab = NULL;
}
static void
rdsymtab(unused,name,p)
int unused;
void *name;
void *p;
{
	char *buf;
	FILE *fp;
	unsigned short seg;
	unsigned short offs;
	struct symtab *sp;
	struct symtab **spp;
	int size = 0;
	int i;

	if((fp = fopen(name,"rt")) == NULL){
		printf("can't read %s\n",name);
		return;
	}
	buf = (char *)malloc(128);
	while(fgets(buf,128,fp),!feof(fp)){
		rip(buf);
		if(strcmp(buf,"  Address         Publics by Value") == 0)
			break;
	}
	if(feof(fp)){
		printf("Can't find header line in %s\n",name);
		free(buf);
		return;
	}
	Symtab = NULL;
	while(fgets(buf,128,fp),!feof(fp)){
		rip(buf);
		if(sscanf(buf,"%x:%x",&seg,&offs) != 2)
			continue;
		sp = (struct symtab *)malloc(sizeof(struct symtab));
		sp->offs = offs;
		sp->seg = seg;
		sp->name = strdup(buf+17);
		sp->next = Symtab;
		Symtab = sp;
		size++;
	}
	fclose(fp);
	free(buf);
#ifdef	notdef
	printf("Symbols read: %d\n",size);
#endif
	/* Sort the symbols using the quicksort library function */
	spp = malloc(size*sizeof(struct symtab *));
	for(i=0,sp = Symtab;sp != NULL;i++,sp = sp->next)
		spp[i] = sp;
	qsort(spp,size,sizeof(struct symtab *),scompare);
	/* Now put them back in the linked list */
	Symtab = NULL;
	for(i=size-1;i >= 0;i--){
		sp = spp[i];
		sp->next = Symtab;
		Symtab = sp;
	}
	free(spp);
#ifdef	notdef
	for(sp = Symtab;sp != NULL;sp = sp->next)
		printf("%x:%x	%s\n",sp->seg,sp->offs,sp->name);
#endif
}
static int
scompare(a,b)
struct symtab **a,**b;
{
	if((*a)->seg > (*b)->seg)
		return 1;
	if((*a)->seg < (*b)->seg)
		return -1;
	if((*a)->offs > (*b)->offs)
		return 1;
	if((*a)->offs < (*b)->offs)
		return -1;
	return 0;
}
/* Print a code address according to the memory model */
static void
paddr(pc)
void (*pc)();
{
#ifdef	LARGECODE
	printf("%04x:%04x",FP_SEG(pc) - Codeseg,FP_OFF(pc));
#else
	printf("%04x",FP_OFF(pc);
#endif	
}
@


1.7
log
@src0519
@
text
@d24 3
a26 3
static void rdsymtab __ARGS((int unused,void *name,void *p));
static void clrsymtab __ARGS((void));
static struct symtab *findsym __ARGS((void (*)()));
d28 1
a28 1
static void paddr __ARGS((void (*pc)()));
d250 1
a250 1
	printf("%04x",FP_OFF(pc));
@


1.6
log
@src0514
@
text
@d64 1
a64 1
	if((cp = strchr(mapname,'.')) != NULLCHAR)
@


1.5
log
@src0505
@
text
@d13 1
d46 2
d49 8
d59 1
a59 1
	printf("Code base segment: %x\r\n",Codeseg);
d86 1
a86 1
			printf("\r\n");
d105 1
a105 1
			printf("%x",*ctmp);
d107 1
a107 1
				printf(" ");
d112 1
a112 1
		printf(")\r\n");
d126 2
a127 1
	pause(10000L);
d178 1
a178 1
		printf("can't read %s\r\n",name);
d188 1
a188 1
		printf("Can't find header line in %s\r\n",name);
d208 1
a208 1
	printf("Symbols read: %d\r\n",size);
d225 1
a225 1
		printf("%x:%x	%s\r\n",sp->seg,sp->offs,sp->name);
a226 1
	return;
@


1.4
log
@src0503
@
text
@d48 1
a48 1
	cprintf("Code base segment: %x\r\n",Codeseg);
d71 1
a71 1
			cprintf(" %s+%x",sp->name,FP_OFF(pc) - sp->offs);
d75 1
a75 1
			cprintf("\r\n");
d92 1
a92 1
		cprintf("(");
d94 1
a94 1
			cprintf("%x",*ctmp);
d96 1
a96 1
				cprintf(" ");
d101 1
a101 1
		cprintf(")\r\n");
d166 1
a166 1
		cprintf("can't read %s\r\n",name);
d176 1
a176 1
		cprintf("Can't find header line in %s\r\n",name);
d196 1
a196 1
	cprintf("Symbols read: %d\r\n",size);
d213 1
a213 1
		cprintf("%x:%x	%s\r\n",sp->seg,sp->offs,sp->name);
d237 1
a237 1
	cprintf("%04x:%04x",FP_SEG(pc) - Codeseg,FP_OFF(pc));
d239 1
a239 1
	cprintf("%04x",FP_OFF(pc));
@


1.3
log
@s920423
@
text
@d115 1
@


1.2
log
@src0419
@
text
@d48 1
a48 1
	printf("Code base segment: %x\n",Codeseg);
d53 1
a53 1
	if((cp = strchr(mapname,'.')) != NULL)
d71 1
a71 1
			printf(" %s+%x",sp->name,FP_OFF(pc) - sp->offs);
d75 1
a75 1
			printf("\n");
d92 1
a92 1
		printf("(");
d94 1
a94 1
			printf("%x",*ctmp);
d96 1
a96 1
				printf(" ");
d101 1
a101 2
		printf(")");
		printf("\n");	
d164 2
a165 2
	if((fp =fopen(name,"r")) == NULL){
		printf("can't read %s\n",name);
d175 1
a175 1
		printf("Can't find header line in %s\n",name);
d195 1
a195 1
	printf("Symbols read: %d\n",size);
d212 1
a212 1
		printf("%x:%x	%s\n",sp->seg,sp->offs,sp->name);
d236 1
a236 1
	printf("%04x:%04x",FP_SEG(pc) - Codeseg,FP_OFF(pc));
d238 1
a238 1
	printf("%04x",FP_OFF(pc));
@


1.1
log
@Initial revision
@
text
@a21 2
void stktrace();

d43 1
a43 1
	char mapname[20];
d51 1
d62 1
@
