head	1.6;
access;
symbols;
locks;
comment	@ * @;


1.6
date	93.05.06.10.11.39;	author karn;	state Exp;
branches;
next	1.5;

1.5
date	92.04.09.08.55.44;	author karn;	state Exp;
branches;
next	1.4;

1.4
date	92.04.07.12.18.12;	author karn;	state Exp;
branches;
next	1.3;

1.3
date	92.04.07.08.37.48;	author karn;	state Exp;
branches;
next	1.2;

1.2
date	91.03.18.07.14.50;	author karn;	state Exp;
branches;
next	1.1;

1.1
date	90.11.10.19.08.28;	author karn;	state Exp;
branches;
next	;


desc
@src0201
@


1.6
log
@Change int16 to uint16
Remove __ARGS(()) construct
@
text
@#ifndef	_UDP_H
#define	_UDP_H

#ifndef	_GLOBAL_H
#include "global.h"
#endif

#ifndef	_MBUF_H
#include "mbuf.h"
#endif

#ifndef	_IFACE_H
#include "iface.h"
#endif

#ifndef	_INTERNET_H
#include "internet.h"
#endif

#ifndef _IP_H
#include "ip.h"
#endif

#ifndef	_NETUSER_H
#include "netuser.h"
#endif

/* SNMP MIB variables, used for statistics and control. See RFC 1066 */
extern struct mib_entry Udp_mib[];
#define	udpInDatagrams	Udp_mib[1].value.integer
#define	udpNoPorts	Udp_mib[2].value.integer
#define	udpInErrors	Udp_mib[3].value.integer
#define	udpOutDatagrams	Udp_mib[4].value.integer
#define	NUMUDPMIB	4

/* User Datagram Protocol definitions */

/* Structure of a UDP protocol header */
struct udp {
	uint16 source;	/* Source port */
	uint16 dest;	/* Destination port */
	uint16 length;	/* Length of header and data */
	uint16 checksum;	/* Checksum over pseudo-header, header and data */
};
#define	UDPHDR	8	/* Length of UDP header */

/* User Datagram Protocol control block
 * Each entry on the receive queue consists of the
 * remote socket structure, followed by any data
 */
struct udp_cb {
	struct udp_cb *next;
	struct socket socket;	/* Local port accepting datagrams */
	void (*r_upcall)(struct iface *iface,struct udp_cb *,int);
				/* Function to call when one arrives */
	struct mbuf *rcvq;	/* Queue of pending datagrams */
	int rcvcnt;		/* Count of pending datagrams */
	int user;		/* User link */
};
extern struct udp_cb *Udps;	/* Hash table for UDP structures */
#define	NULLUDP	(struct udp_cb *)0

/* UDP primitives */

/* In udp.c: */
int del_udp(struct udp_cb *up);
struct udp_cb *open_udp(struct socket *lsocket,
	void (*r_upcall)(struct iface *iface,struct udp_cb *,int));
int recv_udp(struct udp_cb *up,struct socket *fsocket,struct mbuf **bp);
int send_udp(struct socket *lsocket,struct socket *fsocket,char tos,
	char ttl,struct mbuf *data,uint16 length,uint16 id,char df);
void udp_input(struct iface *iface,struct ip *ip,struct mbuf *bp,
	int rxbroadcast);
void udp_garbage(int drastic);

#ifdef HOPCHECK
void udp_icmp(int32 icsource, int32 ipsource,int32 ipdest,
	char ictype,char iccode,struct mbuf **bpp);
/* In hop.c: */
void hop_icmp(struct udp_cb *ucb, int32 icsource, int32 ipdest,
	uint16 udpdest, char ictype, char iccode);
#endif

/* In udpcmd.c: */
int st_udp(struct udp_cb *udp,int n);

/* In udphdr.c: */
struct mbuf *htonudp(struct udp *udp,struct mbuf *data,struct pseudo_header *ph);
int ntohudp(struct udp *udp,struct mbuf **bpp);
uint16 udpcksum(struct mbuf *bp);

/* In udpsocket.c: */
int so_udp(struct usock *up,int protocol);
int so_udp_bind(struct usock *up);
int so_udp_conn(struct usock *up);
int so_udp_recv(struct usock *up,struct mbuf **bpp,char *from,
	int *fromlen);
int so_udp_send(struct usock *up,struct mbuf *bp,char *to);
int so_udp_qlen(struct usock *up,int rtx);
int so_udp_shut(struct usock *up,int how);
int so_udp_close(struct usock *up);
int so_udp_stat(struct usock *up);

#endif	/* _UDP_H */
@


1.5
log
@src0410
@
text
@d40 4
a43 4
	int16 source;	/* Source port */
	int16 dest;	/* Destination port */
	int16 length;	/* Length of header and data */
	int16 checksum;	/* Checksum over pseudo-header, header and data */
d54 1
a54 1
	void (*r_upcall) __ARGS((struct iface *iface,struct udp_cb *,int));
d66 9
a74 9
int del_udp __ARGS((struct udp_cb *up));
struct udp_cb *open_udp __ARGS((struct socket *lsocket,
	void (*r_upcall) __ARGS((struct iface *iface,struct udp_cb *,int))));
int recv_udp __ARGS((struct udp_cb *up,struct socket *fsocket,struct mbuf **bp));
int send_udp __ARGS((struct socket *lsocket,struct socket *fsocket,char tos,
	char ttl,struct mbuf *data,int16 length,int16 id,char df));
void udp_input __ARGS((struct iface *iface,struct ip *ip,struct mbuf *bp,
	int rxbroadcast));
void udp_garbage __ARGS((int drastic));
d77 2
a78 2
void udp_icmp __ARGS((int32 icsource, int32 ipsource,int32 ipdest,
	char ictype,char iccode,struct mbuf **bpp));
d80 2
a81 2
void hop_icmp __ARGS((struct udp_cb *ucb, int32 icsource, int32 ipdest,
	int16 udpdest, char ictype, char iccode));
d85 1
a85 1
int st_udp __ARGS((struct udp_cb *udp,int n));
d88 3
a90 3
struct mbuf *htonudp __ARGS((struct udp *udp,struct mbuf *data,struct pseudo_header *ph));
int ntohudp __ARGS((struct udp *udp,struct mbuf **bpp));
int16 udpcksum __ARGS((struct mbuf *bp));
d93 10
a102 10
int so_udp __ARGS((struct usock *up,int protocol));
int so_udp_bind __ARGS((struct usock *up));
int so_udp_conn __ARGS((struct usock *up));
int so_udp_recv __ARGS((struct usock *up,struct mbuf **bpp,char *from,
	int *fromlen));
int so_udp_send __ARGS((struct usock *up,struct mbuf *bp,char *to));
int so_udp_qlen __ARGS((struct usock *up,int rtx));
int so_udp_shut __ARGS((struct usock *up,int how));
int so_udp_close __ARGS((struct usock *up));
int so_udp_stat __ARGS((struct usock *up));
@


1.4
log
@src0407a
@
text
@d102 1
@


1.3
log
@src0407
@
text
@d93 1
a93 1
int so_udp __ARGS((struct usock *up));
@


1.2
log
@src0318
@
text
@d92 11
@


1.1
log
@Initial revision
@
text
@a36 1
#define	NUDP	20
a51 1
	struct udp_cb *prev;	/* Linked list pointers */
d60 1
a60 1
extern struct udp_cb *Udps[];	/* Hash table for UDP structures */
d90 1
@
