head	1.4;
access;
symbols;
locks;
comment	@ * @;


1.4
date	91.09.18.15.18.30;	author karn;	state Exp;
branches;
next	1.3;

1.3
date	91.06.09.04.44.38;	author karn;	state Exp;
branches;
next	1.2;

1.2
date	91.03.08.00.00.40;	author karn;	state Exp;
branches;
next	1.1;

1.1
date	90.11.03.12.52.22;	author karn;	state Exp;
branches
	1.1.2.1;
next	;

1.1.2.1
date	91.03.08.11.19.40;	author karn;	state Exp;
branches;
next	;


desc
@src0201
@


1.4
log
@src0922
@
text
@/*
 *	PPPDUMP.C
 *
 *	12-89	-- Katie Stevens (dkstevens@@ucdavis.edu)
 *		   UC Davis, Computing Services
 *	PPP.08	05-90	[ks] improve tracing reports
 *	PPP.09  05-90	[ks] add UPAP packet reporting
 *	PPP.14	08-90	[ks] change UPAP to PAP for consistency with RFC1172
 *	PPP.15	09-90	[ks] update to KA9Q NOS v900828
 *	Jan 91	[Bill Simpson] small changes to match rewrite of PPP
 *	Aug 91	[Bill Simpson] fixed some buffer loss
 */
#include <stdio.h>
#include "global.h"
#include "mbuf.h"
#include "iface.h"
#include "internet.h"
#include "ppp.h"
#include "trace.h"

#ifdef TURBOC_SWITCH_BUG
#pragma option -G-
#endif

/* dump a PPP packet */
void
ppp_dump(fp,bpp,unused)
FILE *fp;
struct mbuf **bpp;
int unused;
{
	struct ppp_hdr hdr;
	struct mbuf *tbp;

	fprintf(fp,"PPP: len %3u\t", len_p(*bpp));

	/* HDLC address and control fields may be compressed out */
	if ((byte_t)(*bpp)->data[0] != HDLC_ALL_ADDR) {
		fprintf(fp,"(compressed ALL/UI)\t");
	} else if ((byte_t)(*bpp)->data[1] != HDLC_UI) {
		fprintf(fp,"(missing UI!)\t");
	} else {
		/* skip address/control fields */
		pull16(bpp);
	}

	/* Initialize the expected header */
	hdr.addr = HDLC_ALL_ADDR;
	hdr.control = HDLC_UI;
	hdr.protocol = PULLCHAR(bpp);

	/* First byte of PPP protocol field may be compressed out */
	if ( hdr.protocol & 0x01 ) {
		fprintf(fp,"compressed ");
	} else {
		hdr.protocol = (hdr.protocol << 8) | PULLCHAR(bpp);

		/* Second byte of PPP protocol field must be odd */
		if ( !(hdr.protocol & 0x01) ) {
			fprintf(fp, "(not odd!) " );
		}
	}

	fprintf(fp,"protocol: ");
	switch(hdr.protocol){
		case PPP_IP_PROTOCOL:
			fprintf(fp,"IP\n");
			ip_dump(fp,bpp,1);
			break;
		case PPP_IPCP_PROTOCOL:
			fprintf(fp,"IPCP\n");
			break;
		case PPP_LCP_PROTOCOL:
			fprintf(fp,"LCP\n");
			break;
		case PPP_PAP_PROTOCOL:
			fprintf(fp,"PAP\n");
			break;
		case PPP_COMPR_PROTOCOL:
			fprintf(fp,"VJ Compressed TCP/IP\n");
			vjcomp_dump(fp,bpp,0);
			break;
		case PPP_UNCOMP_PROTOCOL:
			fprintf(fp,"VJ Uncompressed TCP/IP\n");
			/* Get our own copy so we can mess with the data */
			if ( (tbp = copy_p(*bpp, len_p(*bpp))) == NULLBUF)
				return;

			fprintf(fp,"\tconnection 0x%02x\n",
				tbp->data[9]);		/* FIX THIS! */
			/* Restore the bytes used with Uncompressed TCP */
			tbp->data[9] = TCP_PTCL;	/* FIX THIS! */
			ip_dump(fp,&tbp,1);
			free_p(tbp);
			break;
		default:
			fprintf(fp,"unknown 0x%04x\n",hdr.protocol);
			break;
	}
}

#ifdef TURBOC_SWITCH_BUG
#pragma option -G
#endif
@


1.3
log
@src0609
@
text
@d11 1
a15 1
#include "proc.h"
d20 5
a24 1
/*#pragma option -G- */
d32 14
a45 2
	struct ppp_hdr phdr;
	struct mbuf *bp, *tbp;
d47 4
a50 6
	ntohppp(&phdr,bpp);
	fprintf(fp,"PPP: len %3u     ",(PPP_HDR_LEN + len_p(*bpp)));
	if (phdr.addr != HDLC_ALL_ADDR)
		fprintf(fp,"!invalid addr field  ");
	if (phdr.control != HDLC_UI)
		fprintf(fp,"!invalid ctl field  ");
d52 14
a65 1
	switch(phdr.protocol){
d67 1
a67 1
			fprintf(fp,"\t\tprotocol: IP\n");
d71 1
a71 1
			fprintf(fp,"\t\tprotocol: IPCP\n");
d74 1
a74 1
			fprintf(fp,"\t\tprotocol: LCP\n");
d77 1
a77 1
			fprintf(fp,"\t\tprotocol: PAP\n");
d80 1
a80 1
			fprintf(fp,"\t\tprotocol: VJ Compr TCP/IP\n");
d84 1
a84 3
			fprintf(fp,"\t\tprotocol: VJ Uncompr TCP/IP\n");
			fprintf(fp,"VJ Uncompr TCP/IP: connection 0x%02x\n",
				(*bpp)->data[9]);	/* FIX THIS! */
d86 5
a90 2
			bp = *bpp;
			tbp = copy_p(bp, len_p(bp));
d94 1
d97 1
a97 1
			fprintf(fp,"  unknown protocol: 0x%04x\n",phdr.protocol);
d101 4
a104 1
/*#pragma option -G */
@


1.2
log
@src0318
@
text
@d20 1
a20 1

a62 2
			free_p(bp);
			*bpp = NULLBUF;
d72 1
@


1.1
log
@Initial revision
@
text
@d10 1
a17 2
#include "slcompre.h"
#include "slip.h"
d28 1
a28 1
	struct ppphdr phdr;
d32 1
a32 1
	fprintf(fp,"PPP: len %3u     ",(PPP_HDRLEN + len_p(*bpp)));
d38 2
a39 2
	switch(phdr.type){
		case PPP_IP_TYPE:
d43 1
a43 1
		case PPP_IPCP_TYPE:
d46 1
a46 1
		case PPP_LCP_TYPE:
d49 1
a49 1
		case PPP_PAP_TYPE:
d52 1
a52 1
		case PPP_COMPR_TYPE:
d56 1
a56 1
		case PPP_UNCOMP_TYPE:
d58 2
a59 1
			fprintf(fp,"VJ Uncompr TCP/IP: connection 0x%02x\n",(*bpp)->data[9]);	/* FIX THIS! */
d70 1
a70 1
			fprintf(fp,"  unknown protocol: 0x%04x\n",phdr.type);
@


1.1.2.1
log
@src0308
@
text
@d17 1
a17 1
#include "slcomp.h"
@
