head	1.7;
access;
symbols;
locks;
comment	@ * @;


1.7
date	93.01.02.08.34.51;	author karn;	state Exp;
branches;
next	1.6;

1.6
date	92.05.19.22.15.28;	author karn;	state Exp;
branches;
next	1.5;

1.5
date	92.05.11.03.57.02;	author karn;	state Exp;
branches;
next	1.4;

1.4
date	92.05.03.11.03.54;	author karn;	state Exp;
branches;
next	1.3;

1.3
date	92.05.01.11.33.54;	author karn;	state Exp;
branches;
next	1.2;

1.2
date	92.03.29.03.32.50;	author karn;	state Exp;
branches;
next	1.1;

1.1
date	91.01.27.12.34.08;	author karn;	state Exp;
branches;
next	;


desc
@src0201
@


1.7
log
@Name ttylink session "ttylink <remote socket>".
Set line buffering on session.
@
text
@/* Internet TTY "link" (keyboard chat) server
 * Copyright 1991 Phil Karn, KA9Q
 */
#include <stdio.h>
#include "global.h"
#include "mbuf.h"
#include "socket.h"
#include "telnet.h"
#include "session.h"
#include "proc.h"
#include "tty.h"
#include "mailbox.h"
#include "commands.h"

static int Sttylink = -1;	/* Protoype socket for service */

int
ttylstart(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	struct sockaddr_in lsocket;
	int s,type;
	FILE *network;

	if(Sttylink != -1){
		return 0;
	}
	psignal(Curproc,0);	/* Don't keep the parser waiting */
	chname(Curproc,"TTYlink listener");

	lsocket.sin_family = AF_INET;
	lsocket.sin_addr.s_addr = INADDR_ANY;
	if(argc < 2)
		lsocket.sin_port = IPPORT_TTYLINK;
	else
		lsocket.sin_port = atoi(argv[1]);

	Sttylink = socket(AF_INET,SOCK_STREAM,0);
	bind(Sttylink,(char *)&lsocket,sizeof(lsocket));
	listen(Sttylink,1);
	for(;;){
		if((s = accept(Sttylink,NULLCHAR,(int *)NULL)) == -1)
			break;	/* Service is shutting down */
		
		network = fdopen(s,"r+t");
		if(availmem() != 0){
			fprintf(network,"System is overloaded; try again later\n");
			fclose(network);
		} else {
			type = TELNET;
			newproc("chat",2048,ttylhandle,s,
			 (void *)&type,(void *)network,0);
		}
	}
	return 0;
}
/* This function handles all incoming "chat" sessions, be they TCP,
 * NET/ROM or AX.25
 */
void
ttylhandle(s,t,p)
int s;
void *t;
void *p;
{
	int type;
	struct session *sp;
	char addr[MAXSOCKSIZE];
	int len = MAXSOCKSIZE;
	struct telnet tn;
	FILE *network;
	char *tmp;

	type = * (int *)t;
	network = (FILE *)p;
	sockowner(fileno(network),Curproc);	/* We own it now */
	getpeername(fileno(network),addr,&len);
	log(fileno(network),"open %s",Sestypes[type]);
	tmp = malloc(BUFSIZ);
	sprintf(tmp,"ttylink %s",psocket(addr));

	/* Allocate a session descriptor */
	if((sp = newsession(tmp,type,1)) == NULLSESSION){
		fprintf(network,"Too many sessions\n");
		fclose(network);
		free(tmp);
		return;
	}
	free(tmp);
	/* Initialize a Telnet protocol descriptor */
	memset((char *)&tn,0,sizeof(tn));
	tn.session = sp;	/* Upward pointer */
	sp->cb.telnet = &tn;	/* Downward pointer */
	sp->network = network;
	sp->proc = Curproc;
	setvbuf(sp->network,NULLCHAR,_IOLBF,BUFSIZ);

	printf("\007Incoming %s session %u from %s\007\n",
	 Sestypes[type],sp->index,psocket(addr));

	tnrecv(&tn);
}

/* Shut down Ttylink server */
int
ttyl0(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	close_s(Sttylink);
	Sttylink = -1;
	return 0;
}
@


1.6
log
@src0519
@
text
@d74 1
d79 1
d81 2
d85 1
a85 1
	if((sp = newsession(NULLCHAR,type,1)) == NULLSESSION){
d88 1
d91 1
d98 1
a99 1
	getpeername(fileno(network),addr,&len);
@


1.5
log
@src0514
@
text
@d48 1
a48 1
		if(availmem() < Memthresh){
@


1.4
log
@src0503
@
text
@d68 1
a68 1
	int type,index;
a85 2
	index = sp - Sessions;

d95 1
a95 1
	 Sestypes[type],index,psocket(addr));
@


1.3
log
@src0501
@
text
@d47 1
a47 2
		network = fdopen(s,"r+");
		seteol(network,eolseq(s));
a76 1
	fmode(network,STREAM_ASCII);
@


1.2
log
@src0331
@
text
@d25 1
d47 2
d50 2
a51 2
			usprintf(s,"System is overloaded; try again later\n");
			shutdown(s,1);
d54 2
a55 1
			newproc("chat",2048,ttylhandle,s,(void *)&type,NULL,0);
d74 1
d77 4
a80 3
	sockmode(s,SOCK_ASCII);
	sockowner(s,Curproc);	/* We own it now */
	log(s,"open %s",Sestypes[type]);
d84 2
a85 2
		usprintf(s,"Too many sessions\n");
		close_s(s);
d94 1
a94 1
	sp->s = s;
d97 2
a98 2
	getpeername(s,addr,&len);
	tprintf("\007Incoming %s session %u from %s\007\n",
@


1.1
log
@Initial revision
@
text
@d77 1
a77 1
	if((sp = newsession(NULLCHAR,type)) == NULLSESSION){
@
